package cn.iocoder.byzs.module.bjdx.service.coursetype;

import cn.iocoder.byzs.module.bjdx.controller.admin.coursetype.vo.CourseTypeListReqVO;
import cn.iocoder.byzs.module.bjdx.controller.admin.coursetype.vo.CourseTypeSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import cn.iocoder.byzs.module.bjdx.controller.admin.coursetype.vo.*;
import cn.iocoder.byzs.module.bjdx.dal.dataobject.coursetype.CourseTypeDO;
import cn.iocoder.byzs.framework.common.util.object.BeanUtils;

import cn.iocoder.byzs.module.bjdx.dal.mysql.coursetype.CourseTypeMapper;

import static cn.iocoder.byzs.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.byzs.framework.common.util.collection.CollectionUtils.convertList;
import static cn.iocoder.byzs.module.bjdx.enums.ErrorCodeConstants.*;

/**
 * 课程-类型 Service 实现类
 *
 * @author lyb
 */
@Service
@Validated
public class CourseTypeServiceImpl implements CourseTypeService {

    @Resource
    private CourseTypeMapper courseTypeMapper;

    @Override
    public Long createCourseType(CourseTypeSaveReqVO createReqVO) {
        // 校验课程类型父级id的有效性
        validateParentCourseType(null, createReqVO.getCtParentId());
        // 校验课程类型名称的唯一性
        validateCourseTypeCtTypeUnique(null, createReqVO.getCtParentId(), createReqVO.getCtType());

        // 插入
        CourseTypeDO courseType = BeanUtils.toBean(createReqVO, CourseTypeDO.class);
        courseTypeMapper.insert(courseType);
        // 返回
        return courseType.getId();
    }

    @Override
    public void updateCourseType(CourseTypeSaveReqVO updateReqVO) {
        // 校验存在
        validateCourseTypeExists(updateReqVO.getId());
        // 校验课程类型父级id的有效性
        validateParentCourseType(updateReqVO.getId(), updateReqVO.getCtParentId());
        // 校验课程类型名称的唯一性
        validateCourseTypeCtTypeUnique(updateReqVO.getId(), updateReqVO.getCtParentId(), updateReqVO.getCtType());

        // 更新
        CourseTypeDO updateObj = BeanUtils.toBean(updateReqVO, CourseTypeDO.class);
        courseTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteCourseType(Long id) {
        // 校验存在
        validateCourseTypeExists(id);
        // 校验是否有子课程-类型
        if (courseTypeMapper.selectCountByCtParentId(id) > 0) {
            throw exception(COURSE_TYPE_EXITS_CHILDREN);
        }
        // 删除
        courseTypeMapper.deleteById(id);
    }


    private void validateCourseTypeExists(Long id) {
        if (courseTypeMapper.selectById(id) == null) {
            throw exception(COURSE_TYPE_NOT_EXISTS);
        }
    }

    private void validateParentCourseType(Long id, Long ctParentId) {
        if (ctParentId == null || CourseTypeDO.CT_PARENT_ID_ROOT.equals(ctParentId)) {
            return;
        }
        // 1. 不能设置自己为父课程-类型
        if (Objects.equals(id, ctParentId)) {
            throw exception(COURSE_TYPE_PARENT_ERROR);
        }
        // 2. 父课程-类型不存在
        CourseTypeDO parentCourseType = courseTypeMapper.selectById(ctParentId);
        if (parentCourseType == null) {
            throw exception(COURSE_TYPE_PARENT_NOT_EXITS);
        }
        // 3. 递归校验父课程-类型，如果父课程-类型是自己的子课程-类型，则报错，避免形成环路
        if (id == null) { // id 为空，说明新增，不需要考虑环路
            return;
        }
        for (int i = 0; i < Short.MAX_VALUE; i++) {
            // 3.1 校验环路
            ctParentId = parentCourseType.getCtParentId();
            if (Objects.equals(id, ctParentId)) {
                throw exception(COURSE_TYPE_PARENT_IS_CHILD);
            }
            // 3.2 继续递归下一级父课程-类型
            if (ctParentId == null || CourseTypeDO.CT_PARENT_ID_ROOT.equals(ctParentId)) {
                break;
            }
            parentCourseType = courseTypeMapper.selectById(ctParentId);
            if (parentCourseType == null) {
                break;
            }
        }
    }

    private void validateCourseTypeCtTypeUnique(Long id, Long ctParentId, String ctType) {
        CourseTypeDO courseType = courseTypeMapper.selectByCtParentIdAndCtType(ctParentId, ctType);
        if (courseType == null) {
            return;
        }
        // 如果 id 为空，说明不用比较是否为相同 id 的课程-类型
        if (id == null) {
            throw exception(COURSE_TYPE_CT_TYPE_DUPLICATE);
        }
        if (!Objects.equals(courseType.getId(), id)) {
            throw exception(COURSE_TYPE_CT_TYPE_DUPLICATE);
        }
    }

    @Override
    public CourseTypeDO getCourseType(Long id) {
        return courseTypeMapper.selectById(id);
    }

    @Override
    public List<CourseTypeDO> getCourseTypeList(CourseTypeListReqVO listReqVO) {
        return courseTypeMapper.selectList(listReqVO);
    }

}